#ifdef ATL_UCLEANM
#define ATL_dJIK0x40x40TN40x40x0_a1_b0 ATL_dgpMBmm_b0
#else
#define ATL_dJIK0x40x40TN40x40x0_a1_b0 ATL_dpMBmm_b0
#endif

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x40x40TN1x4x40_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=40, KB=40, 
 * lda=40, ldb=40, ldc=0, mu=1, nu=4, ku=40, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   const double *stM = A + (((Mb) << 5)+((Mb) << 3));
   const double *stN = B + 1600;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*4)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 40
   const int incAm = 0, incAn = -(((Mb) << 5)+((Mb) << 3));
   #define incBk 40
   const int incBm = -40, incBn = 160;
   const int incAk0 = ((incAk) / 40), incBk0 = ((incBk) / 40);
   #define incCm 1
   const int incCn = (((ldc) << 2)) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3;
   register double m0, m1, m2, m3, m4;
   register double rC0_0, rC0_1, rC0_2, rC0_3;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[40];
         rB2 = pB0[80];
         rB3 = pB0[120];
         m0 = rA0 * rB0;
         m1 = rA0 * rB1;
         m2 = rA0 * rB2;
         m3 = rA0 * rB3;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rB1 = pB0[41];
         rB2 = pB0[81];
         rB3 = pB0[121];
         m4 = rA0 * rB0;

/*
 *       Completely unrolled K-loop
 */
         rC0_0 = m0;
         m0 = rA0 * rB1;
         rC0_1 = m1;
         m1 = rA0 * rB2;
         rC0_2 = m2;
         m2 = rA0 * rB3;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB0[42];
         rB2 = pB0[82];
         rB3 = pB0[122];
         rC0_3 = m3;
         m3 = rA0 * rB0;
         rC0_0 += m4;
         m4 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m1;
         m1 = rA0 * rB3;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rB1 = pB0[43];
         rB2 = pB0[83];
         rB3 = pB0[123];
         rC0_3 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m3;
         m3 = rA0 * rB1;
         rC0_1 += m4;
         m4 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rB1 = pB0[44];
         rB2 = pB0[84];
         rB3 = pB0[124];
         rC0_3 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA0 * rB1;
         rC0_1 += m3;
         m3 = rA0 * rB2;
         rC0_2 += m4;
         m4 = rA0 * rB3;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rB1 = pB0[45];
         rB2 = pB0[85];
         rB3 = pB0[125];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA0 * rB1;
         rC0_1 += m2;
         m2 = rA0 * rB2;
         rC0_2 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rB1 = pB0[46];
         rB2 = pB0[86];
         rB3 = pB0[126];
         rC0_3 += m4;
         m4 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m1;
         m1 = rA0 * rB2;
         rC0_2 += m2;
         m2 = rA0 * rB3;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rB1 = pB0[47];
         rB2 = pB0[87];
         rB3 = pB0[127];
         rC0_3 += m3;
         m3 = rA0 * rB0;
         rC0_0 += m4;
         m4 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m1;
         m1 = rA0 * rB3;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rB1 = pB0[48];
         rB2 = pB0[88];
         rB3 = pB0[128];
         rC0_3 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m3;
         m3 = rA0 * rB1;
         rC0_1 += m4;
         m4 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rB1 = pB0[49];
         rB2 = pB0[89];
         rB3 = pB0[129];
         rC0_3 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA0 * rB1;
         rC0_1 += m3;
         m3 = rA0 * rB2;
         rC0_2 += m4;
         m4 = rA0 * rB3;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rB1 = pB0[50];
         rB2 = pB0[90];
         rB3 = pB0[130];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA0 * rB1;
         rC0_1 += m2;
         m2 = rA0 * rB2;
         rC0_2 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rB1 = pB0[51];
         rB2 = pB0[91];
         rB3 = pB0[131];
         rC0_3 += m4;
         m4 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m1;
         m1 = rA0 * rB2;
         rC0_2 += m2;
         m2 = rA0 * rB3;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rB1 = pB0[52];
         rB2 = pB0[92];
         rB3 = pB0[132];
         rC0_3 += m3;
         m3 = rA0 * rB0;
         rC0_0 += m4;
         m4 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m1;
         m1 = rA0 * rB3;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rB1 = pB0[53];
         rB2 = pB0[93];
         rB3 = pB0[133];
         rC0_3 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m3;
         m3 = rA0 * rB1;
         rC0_1 += m4;
         m4 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rB1 = pB0[54];
         rB2 = pB0[94];
         rB3 = pB0[134];
         rC0_3 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA0 * rB1;
         rC0_1 += m3;
         m3 = rA0 * rB2;
         rC0_2 += m4;
         m4 = rA0 * rB3;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rB1 = pB0[55];
         rB2 = pB0[95];
         rB3 = pB0[135];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA0 * rB1;
         rC0_1 += m2;
         m2 = rA0 * rB2;
         rC0_2 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rB1 = pB0[56];
         rB2 = pB0[96];
         rB3 = pB0[136];
         rC0_3 += m4;
         m4 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m1;
         m1 = rA0 * rB2;
         rC0_2 += m2;
         m2 = rA0 * rB3;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rB1 = pB0[57];
         rB2 = pB0[97];
         rB3 = pB0[137];
         rC0_3 += m3;
         m3 = rA0 * rB0;
         rC0_0 += m4;
         m4 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m1;
         m1 = rA0 * rB3;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rB1 = pB0[58];
         rB2 = pB0[98];
         rB3 = pB0[138];
         rC0_3 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m3;
         m3 = rA0 * rB1;
         rC0_1 += m4;
         m4 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[19];
         rB0 = pB0[19];
         rB1 = pB0[59];
         rB2 = pB0[99];
         rB3 = pB0[139];
         rC0_3 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA0 * rB1;
         rC0_1 += m3;
         m3 = rA0 * rB2;
         rC0_2 += m4;
         m4 = rA0 * rB3;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rB1 = pB0[60];
         rB2 = pB0[100];
         rB3 = pB0[140];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA0 * rB1;
         rC0_1 += m2;
         m2 = rA0 * rB2;
         rC0_2 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[21];
         rB0 = pB0[21];
         rB1 = pB0[61];
         rB2 = pB0[101];
         rB3 = pB0[141];
         rC0_3 += m4;
         m4 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m1;
         m1 = rA0 * rB2;
         rC0_2 += m2;
         m2 = rA0 * rB3;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rB1 = pB0[62];
         rB2 = pB0[102];
         rB3 = pB0[142];
         rC0_3 += m3;
         m3 = rA0 * rB0;
         rC0_0 += m4;
         m4 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m1;
         m1 = rA0 * rB3;
         rA0 = pA0[23];
         rB0 = pB0[23];
         rB1 = pB0[63];
         rB2 = pB0[103];
         rB3 = pB0[143];
         rC0_3 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m3;
         m3 = rA0 * rB1;
         rC0_1 += m4;
         m4 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rB1 = pB0[64];
         rB2 = pB0[104];
         rB3 = pB0[144];
         rC0_3 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA0 * rB1;
         rC0_1 += m3;
         m3 = rA0 * rB2;
         rC0_2 += m4;
         m4 = rA0 * rB3;
         rA0 = pA0[25];
         rB0 = pB0[25];
         rB1 = pB0[65];
         rB2 = pB0[105];
         rB3 = pB0[145];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA0 * rB1;
         rC0_1 += m2;
         m2 = rA0 * rB2;
         rC0_2 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rB1 = pB0[66];
         rB2 = pB0[106];
         rB3 = pB0[146];
         rC0_3 += m4;
         m4 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m1;
         m1 = rA0 * rB2;
         rC0_2 += m2;
         m2 = rA0 * rB3;
         rA0 = pA0[27];
         rB0 = pB0[27];
         rB1 = pB0[67];
         rB2 = pB0[107];
         rB3 = pB0[147];
         rC0_3 += m3;
         m3 = rA0 * rB0;
         rC0_0 += m4;
         m4 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m1;
         m1 = rA0 * rB3;
         rA0 = pA0[28];
         rB0 = pB0[28];
         rB1 = pB0[68];
         rB2 = pB0[108];
         rB3 = pB0[148];
         rC0_3 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m3;
         m3 = rA0 * rB1;
         rC0_1 += m4;
         m4 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[29];
         rB0 = pB0[29];
         rB1 = pB0[69];
         rB2 = pB0[109];
         rB3 = pB0[149];
         rC0_3 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA0 * rB1;
         rC0_1 += m3;
         m3 = rA0 * rB2;
         rC0_2 += m4;
         m4 = rA0 * rB3;
         rA0 = pA0[30];
         rB0 = pB0[30];
         rB1 = pB0[70];
         rB2 = pB0[110];
         rB3 = pB0[150];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA0 * rB1;
         rC0_1 += m2;
         m2 = rA0 * rB2;
         rC0_2 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[31];
         rB0 = pB0[31];
         rB1 = pB0[71];
         rB2 = pB0[111];
         rB3 = pB0[151];
         rC0_3 += m4;
         m4 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m1;
         m1 = rA0 * rB2;
         rC0_2 += m2;
         m2 = rA0 * rB3;
         rA0 = pA0[32];
         rB0 = pB0[32];
         rB1 = pB0[72];
         rB2 = pB0[112];
         rB3 = pB0[152];
         rC0_3 += m3;
         m3 = rA0 * rB0;
         rC0_0 += m4;
         m4 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m1;
         m1 = rA0 * rB3;
         rA0 = pA0[33];
         rB0 = pB0[33];
         rB1 = pB0[73];
         rB2 = pB0[113];
         rB3 = pB0[153];
         rC0_3 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m3;
         m3 = rA0 * rB1;
         rC0_1 += m4;
         m4 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[34];
         rB0 = pB0[34];
         rB1 = pB0[74];
         rB2 = pB0[114];
         rB3 = pB0[154];
         rC0_3 += m1;
         m1 = rA0 * rB0;
         rC0_0 += m2;
         m2 = rA0 * rB1;
         rC0_1 += m3;
         m3 = rA0 * rB2;
         rC0_2 += m4;
         m4 = rA0 * rB3;
         rA0 = pA0[35];
         rB0 = pB0[35];
         rB1 = pB0[75];
         rB2 = pB0[115];
         rB3 = pB0[155];
         rC0_3 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m1;
         m1 = rA0 * rB1;
         rC0_1 += m2;
         m2 = rA0 * rB2;
         rC0_2 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[36];
         rB0 = pB0[36];
         rB1 = pB0[76];
         rB2 = pB0[116];
         rB3 = pB0[156];
         rC0_3 += m4;
         m4 = rA0 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC0_1 += m1;
         m1 = rA0 * rB2;
         rC0_2 += m2;
         m2 = rA0 * rB3;
         rA0 = pA0[37];
         rB0 = pB0[37];
         rB1 = pB0[77];
         rB2 = pB0[117];
         rB3 = pB0[157];
         rC0_3 += m3;
         m3 = rA0 * rB0;
         rC0_0 += m4;
         m4 = rA0 * rB1;
         rC0_1 += m0;
         m0 = rA0 * rB2;
         rC0_2 += m1;
         m1 = rA0 * rB3;
         rA0 = pA0[38];
         rB0 = pB0[38];
         rB1 = pB0[78];
         rB2 = pB0[118];
         rB3 = pB0[158];
         rC0_3 += m2;
         m2 = rA0 * rB0;
         rC0_0 += m3;
         m3 = rA0 * rB1;
         rC0_1 += m4;
         m4 = rA0 * rB2;
         rC0_2 += m0;
         m0 = rA0 * rB3;
         rA0 = pA0[39];
         rB0 = pB0[39];
         rB1 = pB0[79];
         rB2 = pB0[119];
         rB3 = pB0[159];
         rC0_3 += m1;
         m1 = rA0 * rB0;
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m2;
         m2 = rA0 * rB1;
         rC0_1 += m3;
         m3 = rA0 * rB2;
         rC0_2 += m4;
         m4 = rA0 * rB3;
         rC0_3 += m0;
         rC0_0 += m1;
         rC0_1 += m2;
         rC0_2 += m3;
         rC0_3 += m4;
         pA0 += incAk;
         pB0 += incBk;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK0x40x40TN40x40x0_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=40, KB=40, 
 * lda=40, ldb=40, ldc=0, mu=2, nu=4, ku=40, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const int Mb = (M>>1)<<1;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((Mb) << 5)+((Mb) << 3));
   const double *stN = B + 1600;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*4)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 40
   const int incAm = 40, incAn = -(((Mb) << 5)+((Mb) << 3));
   #define incBk 40
   const int incBm = -40, incBn = 160;
   const int incAk0 = ((incAk) / 40), incBk0 = ((incBk) / 40);
   #define incCm 2
   const int incCn = (((ldc) << 2)) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0, rB1, rB2, rB3;
   register double m0, m1, m2, m3, m4, m5;
   register double rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            ATL_pfl1W(pC0);
            ATL_pfl1W(pC1);
            ATL_pfl1W(pC2);
            ATL_pfl1W(pC3);
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[40];
            rB1 = pB0[40];
            rB2 = pB0[80];
            m0 = rA0 * rB0;
            rB3 = pB0[120];
            m1 = rA1 * rB0;
            m2 = rA0 * rB1;
            m3 = rA1 * rB1;
            m4 = rA0 * rB2;
            m5 = rA1 * rB2;

/*
 *          Completely unrolled K-loop
 */
            rC0_0 = m0;
            m0 = rA0 * rB3;
            rC1_0 = m1;
            m1 = rA1 * rB3;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[41];
            rB1 = pB0[41];
            rB2 = pB0[81];
            rB3 = pB0[121];
            rC0_1 = m2;
            m2 = rA0 * rB0;
            rC1_1 = m3;
            m3 = rA1 * rB0;
            rC0_2 = m4;
            m4 = rA0 * rB1;
            rC1_2 = m5;
            m5 = rA1 * rB1;
            rC0_3 = m0;
            m0 = rA0 * rB2;
            rC1_3 = m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[42];
            rB1 = pB0[42];
            rB2 = pB0[82];
            rB3 = pB0[122];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[43];
            rB1 = pB0[43];
            rB2 = pB0[83];
            rB3 = pB0[123];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[44];
            rB1 = pB0[44];
            rB2 = pB0[84];
            rB3 = pB0[124];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[45];
            rB1 = pB0[45];
            rB2 = pB0[85];
            rB3 = pB0[125];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[46];
            rB1 = pB0[46];
            rB2 = pB0[86];
            rB3 = pB0[126];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[47];
            rB1 = pB0[47];
            rB2 = pB0[87];
            rB3 = pB0[127];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rA1 = pA0[48];
            rB1 = pB0[48];
            rB2 = pB0[88];
            rB3 = pB0[128];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rA1 = pA0[49];
            rB1 = pB0[49];
            rB2 = pB0[89];
            rB3 = pB0[129];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rA1 = pA0[50];
            rB1 = pB0[50];
            rB2 = pB0[90];
            rB3 = pB0[130];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rA1 = pA0[51];
            rB1 = pB0[51];
            rB2 = pB0[91];
            rB3 = pB0[131];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rA1 = pA0[52];
            rB1 = pB0[52];
            rB2 = pB0[92];
            rB3 = pB0[132];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rA1 = pA0[53];
            rB1 = pB0[53];
            rB2 = pB0[93];
            rB3 = pB0[133];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rA1 = pA0[54];
            rB1 = pB0[54];
            rB2 = pB0[94];
            rB3 = pB0[134];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rA1 = pA0[55];
            rB1 = pB0[55];
            rB2 = pB0[95];
            rB3 = pB0[135];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rA1 = pA0[56];
            rB1 = pB0[56];
            rB2 = pB0[96];
            rB3 = pB0[136];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rA1 = pA0[57];
            rB1 = pB0[57];
            rB2 = pB0[97];
            rB3 = pB0[137];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rA1 = pA0[58];
            rB1 = pB0[58];
            rB2 = pB0[98];
            rB3 = pB0[138];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[19];
            rB0 = pB0[19];
            rA1 = pA0[59];
            rB1 = pB0[59];
            rB2 = pB0[99];
            rB3 = pB0[139];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[20];
            rB0 = pB0[20];
            rA1 = pA0[60];
            rB1 = pB0[60];
            rB2 = pB0[100];
            rB3 = pB0[140];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[21];
            rB0 = pB0[21];
            rA1 = pA0[61];
            rB1 = pB0[61];
            rB2 = pB0[101];
            rB3 = pB0[141];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[22];
            rB0 = pB0[22];
            rA1 = pA0[62];
            rB1 = pB0[62];
            rB2 = pB0[102];
            rB3 = pB0[142];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[23];
            rB0 = pB0[23];
            rA1 = pA0[63];
            rB1 = pB0[63];
            rB2 = pB0[103];
            rB3 = pB0[143];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[24];
            rB0 = pB0[24];
            rA1 = pA0[64];
            rB1 = pB0[64];
            rB2 = pB0[104];
            rB3 = pB0[144];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[25];
            rB0 = pB0[25];
            rA1 = pA0[65];
            rB1 = pB0[65];
            rB2 = pB0[105];
            rB3 = pB0[145];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[26];
            rB0 = pB0[26];
            rA1 = pA0[66];
            rB1 = pB0[66];
            rB2 = pB0[106];
            rB3 = pB0[146];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[27];
            rB0 = pB0[27];
            rA1 = pA0[67];
            rB1 = pB0[67];
            rB2 = pB0[107];
            rB3 = pB0[147];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[28];
            rB0 = pB0[28];
            rA1 = pA0[68];
            rB1 = pB0[68];
            rB2 = pB0[108];
            rB3 = pB0[148];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[29];
            rB0 = pB0[29];
            rA1 = pA0[69];
            rB1 = pB0[69];
            rB2 = pB0[109];
            rB3 = pB0[149];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[30];
            rB0 = pB0[30];
            rA1 = pA0[70];
            rB1 = pB0[70];
            rB2 = pB0[110];
            rB3 = pB0[150];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[31];
            rB0 = pB0[31];
            rA1 = pA0[71];
            rB1 = pB0[71];
            rB2 = pB0[111];
            rB3 = pB0[151];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[32];
            rB0 = pB0[32];
            rA1 = pA0[72];
            rB1 = pB0[72];
            rB2 = pB0[112];
            rB3 = pB0[152];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[33];
            rB0 = pB0[33];
            rA1 = pA0[73];
            rB1 = pB0[73];
            rB2 = pB0[113];
            rB3 = pB0[153];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[34];
            rB0 = pB0[34];
            rA1 = pA0[74];
            rB1 = pB0[74];
            rB2 = pB0[114];
            rB3 = pB0[154];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[35];
            rB0 = pB0[35];
            rA1 = pA0[75];
            rB1 = pB0[75];
            rB2 = pB0[115];
            rB3 = pB0[155];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[36];
            rB0 = pB0[36];
            rA1 = pA0[76];
            rB1 = pB0[76];
            rB2 = pB0[116];
            rB3 = pB0[156];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[37];
            rB0 = pB0[37];
            rA1 = pA0[77];
            rB1 = pB0[77];
            rB2 = pB0[117];
            rB3 = pB0[157];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[38];
            rB0 = pB0[38];
            rA1 = pA0[78];
            rB1 = pB0[78];
            rB2 = pB0[118];
            rB3 = pB0[158];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[39];
            rB0 = pB0[39];
            rA1 = pA0[79];
            rB1 = pB0[79];
            rB2 = pB0[119];
            rB3 = pB0[159];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rC0_1 += m2;
            rC1_1 += m3;
            rC0_2 += m4;
            rC1_2 += m5;
            rC0_3 += m0;
            rC1_3 += m1;
            pA0 += incAk;
            pB0 += incBk;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            *pC1 = rC0_1;
            pC1[1] = rC1_1;
            *pC2 = rC0_2;
            pC2[1] = rC1_2;
            *pC3 = rC0_3;
            pC3[1] = rC1_3;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_dJIK0x40x40TN1x4x40_a1_b0(k, 40, 40, alpha, ca + (((Mb) << 5)+((Mb) << 3)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
