#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_zJIK16x16x16NN0x0x0_aX_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=16, NB=16, KB=16, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=4, ku=16, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const double *stM = A + 32;
   const double *stN = B + (((ldb) << 5));
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 4 - (((lda) << 5)), incAn = -32;
   #define incBk 32
   const int incBm = -32, incBn = (((ldb) << 3));
   #define incAk0 incAk
   const int incBk0 = ((incBk) >> 4);
   #define incCm 4
   const int incCn = (((ldc) << 3)) - 32;
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(((ldb) << 1)), *pB2=pB1+(((ldb) << 1)), *pB3=pB2+(((ldb) << 1));
   register int k;
   register double rA0, rA1;
   register double rB0, rB1, rB2, rB3;
   register double m0, m1, m2, m3, m4, m5, m6, m7;
   register double rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      pfA += lda;
      do /* M-loop */
      {
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rB1 = *pB1;
         rB2 = *pB2;
         m0 = rA0 * rB0;
         rB3 = *pB3;
         m1 = rA1 * rB0;
         m2 = rA0 * rB1;
         m3 = rA1 * rB1;
         m4 = rA0 * rB2;
         m5 = rA1 * rB2;
         m6 = rA0 * rB3;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[2];
         rA1 = pA0[2];
         rB1 = pB1[2];
         rB2 = pB2[2];
         rB3 = pB3[2];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 = m0;
         m0 = rA0 * rB0;
         rC1_0 = m1;
         m1 = rA1 * rB0;
         rC0_1 = m2;
         m2 = rA0 * rB1;
         rC1_1 = m3;
         m3 = rA1 * rB1;
         rC0_2 = m4;
         m4 = rA0 * rB2;
         rC1_2 = m5;
         m5 = rA1 * rB2;
         rC0_3 = m6;
         m6 = rA0 * rB3;
         rC1_3 = m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[4];
         rA1 = pA0[2];
         rB1 = pB1[4];
         rB2 = pB2[4];
         rB3 = pB3[4];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rC0_2 += m4;
         m4 = rA0 * rB2;
         rC1_2 += m5;
         m5 = rA1 * rB2;
         rC0_3 += m6;
         m6 = rA0 * rB3;
         rC1_3 += m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[6];
         rA1 = pA0[2];
         rB1 = pB1[6];
         rB2 = pB2[6];
         rB3 = pB3[6];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rC0_2 += m4;
         m4 = rA0 * rB2;
         rC1_2 += m5;
         m5 = rA1 * rB2;
         rC0_3 += m6;
         m6 = rA0 * rB3;
         rC1_3 += m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[8];
         rA1 = pA0[2];
         rB1 = pB1[8];
         rB2 = pB2[8];
         rB3 = pB3[8];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rC0_2 += m4;
         m4 = rA0 * rB2;
         rC1_2 += m5;
         m5 = rA1 * rB2;
         rC0_3 += m6;
         m6 = rA0 * rB3;
         rC1_3 += m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[10];
         rA1 = pA0[2];
         rB1 = pB1[10];
         rB2 = pB2[10];
         rB3 = pB3[10];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rC0_2 += m4;
         m4 = rA0 * rB2;
         rC1_2 += m5;
         m5 = rA1 * rB2;
         rC0_3 += m6;
         m6 = rA0 * rB3;
         rC1_3 += m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[12];
         rA1 = pA0[2];
         rB1 = pB1[12];
         rB2 = pB2[12];
         rB3 = pB3[12];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rC0_2 += m4;
         m4 = rA0 * rB2;
         rC1_2 += m5;
         m5 = rA1 * rB2;
         rC0_3 += m6;
         m6 = rA0 * rB3;
         rC1_3 += m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[14];
         rA1 = pA0[2];
         rB1 = pB1[14];
         rB2 = pB2[14];
         rB3 = pB3[14];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rC0_2 += m4;
         m4 = rA0 * rB2;
         rC1_2 += m5;
         m5 = rA1 * rB2;
         rC0_3 += m6;
         m6 = rA0 * rB3;
         rC1_3 += m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[16];
         rA1 = pA0[2];
         rB1 = pB1[16];
         rB2 = pB2[16];
         rB3 = pB3[16];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rC0_2 += m4;
         m4 = rA0 * rB2;
         rC1_2 += m5;
         m5 = rA1 * rB2;
         rC0_3 += m6;
         m6 = rA0 * rB3;
         rC1_3 += m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[18];
         rA1 = pA0[2];
         rB1 = pB1[18];
         rB2 = pB2[18];
         rB3 = pB3[18];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rC0_2 += m4;
         m4 = rA0 * rB2;
         rC1_2 += m5;
         m5 = rA1 * rB2;
         rC0_3 += m6;
         m6 = rA0 * rB3;
         rC1_3 += m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[20];
         rA1 = pA0[2];
         rB1 = pB1[20];
         rB2 = pB2[20];
         rB3 = pB3[20];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rC0_2 += m4;
         m4 = rA0 * rB2;
         rC1_2 += m5;
         m5 = rA1 * rB2;
         rC0_3 += m6;
         m6 = rA0 * rB3;
         rC1_3 += m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[22];
         rA1 = pA0[2];
         rB1 = pB1[22];
         rB2 = pB2[22];
         rB3 = pB3[22];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rC0_2 += m4;
         m4 = rA0 * rB2;
         rC1_2 += m5;
         m5 = rA1 * rB2;
         rC0_3 += m6;
         m6 = rA0 * rB3;
         rC1_3 += m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[24];
         rA1 = pA0[2];
         rB1 = pB1[24];
         rB2 = pB2[24];
         rB3 = pB3[24];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rC0_2 += m4;
         m4 = rA0 * rB2;
         rC1_2 += m5;
         m5 = rA1 * rB2;
         rC0_3 += m6;
         m6 = rA0 * rB3;
         rC1_3 += m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[26];
         rA1 = pA0[2];
         rB1 = pB1[26];
         rB2 = pB2[26];
         rB3 = pB3[26];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rC0_2 += m4;
         m4 = rA0 * rB2;
         rC1_2 += m5;
         m5 = rA1 * rB2;
         rC0_3 += m6;
         m6 = rA0 * rB3;
         rC1_3 += m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[28];
         rA1 = pA0[2];
         rB1 = pB1[28];
         rB2 = pB2[28];
         rB3 = pB3[28];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rC0_2 += m4;
         m4 = rA0 * rB2;
         rC1_2 += m5;
         m5 = rA1 * rB2;
         rC0_3 += m6;
         m6 = rA0 * rB3;
         rC1_3 += m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[30];
         rA1 = pA0[2];
         rB1 = pB1[30];
         rB2 = pB2[30];
         rB3 = pB3[30];
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         rC0_2 += m4;
         m4 = rA0 * rB2;
         rC1_2 += m5;
         m5 = rA1 * rB2;
         rC0_3 += m6;
         m6 = rA0 * rB3;
         rC1_3 += m7;
         m7 = rA1 * rB3;
         pA0 += incAk;
         rC0_0 += m0;
         rC1_0 += m1;
         rC0_1 += m2;
         rC1_1 += m3;
         rC0_2 += m4;
         rC1_2 += m5;
         rC0_3 += m6;
         rC1_3 += m7;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC1_2 *= rB0;
         rC1_3 *= rB0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         *pC1 = rC0_1;
         pC1[2] = rC1_1;
         *pC2 = rC0_2;
         pC2[2] = rC1_2;
         *pC3 = rC0_3;
         pC3[2] = rC1_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
