#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK0x32x32TN1x4x32_a1_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=32, KB=32, 
 * lda=32, ldb=32, ldc=0, mu=1, nu=4, ku=32, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   const double *stM = A + (((Mb) << 5));
   const double *stN = B + 1024;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*4)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 32
   const int incAm = 0, incAn = -(((Mb) << 5));
   #define incBk 32
   const int incBm = -32, incBn = 128;
   const int incAk0 = ((incAk) >> 5), incBk0 = ((incBk) >> 5);
   #define incCm 2
   const int incCn = (((ldc) << 3)) - (((Mb) << 1));
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3;
   register double m0, m1, m2, m3, m4, m5, m6, m7;
   register double rC0_0, rC0_1, rC0_2, rC0_3;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         rC0_3 = *pC3;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[32];
         rB2 = pB0[64];
         rB3 = pB0[96];
         m0 = rA0 * rB0;
         m1 = rA0 * rB1;
         m2 = rA0 * rB2;
         m3 = rA0 * rB3;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rB1 = pB0[33];
         rB2 = pB0[65];
         rB3 = pB0[97];
         m4 = rA0 * rB0;
         m5 = rA0 * rB1;
         m6 = rA0 * rB2;
         m7 = rA0 * rB3;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB0[34];
         rB2 = pB0[66];
         rB3 = pB0[98];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rB1 = pB0[35];
         rB2 = pB0[67];
         rB3 = pB0[99];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rB1 = pB0[36];
         rB2 = pB0[68];
         rB3 = pB0[100];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rB1 = pB0[37];
         rB2 = pB0[69];
         rB3 = pB0[101];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rB1 = pB0[38];
         rB2 = pB0[70];
         rB3 = pB0[102];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rB1 = pB0[39];
         rB2 = pB0[71];
         rB3 = pB0[103];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rB1 = pB0[40];
         rB2 = pB0[72];
         rB3 = pB0[104];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rB1 = pB0[41];
         rB2 = pB0[73];
         rB3 = pB0[105];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rB1 = pB0[42];
         rB2 = pB0[74];
         rB3 = pB0[106];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rB1 = pB0[43];
         rB2 = pB0[75];
         rB3 = pB0[107];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rB1 = pB0[44];
         rB2 = pB0[76];
         rB3 = pB0[108];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rB1 = pB0[45];
         rB2 = pB0[77];
         rB3 = pB0[109];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rB1 = pB0[46];
         rB2 = pB0[78];
         rB3 = pB0[110];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rB1 = pB0[47];
         rB2 = pB0[79];
         rB3 = pB0[111];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rB1 = pB0[48];
         rB2 = pB0[80];
         rB3 = pB0[112];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rB1 = pB0[49];
         rB2 = pB0[81];
         rB3 = pB0[113];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rB1 = pB0[50];
         rB2 = pB0[82];
         rB3 = pB0[114];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[19];
         rB0 = pB0[19];
         rB1 = pB0[51];
         rB2 = pB0[83];
         rB3 = pB0[115];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rB1 = pB0[52];
         rB2 = pB0[84];
         rB3 = pB0[116];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[21];
         rB0 = pB0[21];
         rB1 = pB0[53];
         rB2 = pB0[85];
         rB3 = pB0[117];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rB1 = pB0[54];
         rB2 = pB0[86];
         rB3 = pB0[118];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[23];
         rB0 = pB0[23];
         rB1 = pB0[55];
         rB2 = pB0[87];
         rB3 = pB0[119];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rB1 = pB0[56];
         rB2 = pB0[88];
         rB3 = pB0[120];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[25];
         rB0 = pB0[25];
         rB1 = pB0[57];
         rB2 = pB0[89];
         rB3 = pB0[121];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rB1 = pB0[58];
         rB2 = pB0[90];
         rB3 = pB0[122];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[27];
         rB0 = pB0[27];
         rB1 = pB0[59];
         rB2 = pB0[91];
         rB3 = pB0[123];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[28];
         rB0 = pB0[28];
         rB1 = pB0[60];
         rB2 = pB0[92];
         rB3 = pB0[124];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[29];
         rB0 = pB0[29];
         rB1 = pB0[61];
         rB2 = pB0[93];
         rB3 = pB0[125];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rA0 = pA0[30];
         rB0 = pB0[30];
         rB1 = pB0[62];
         rB2 = pB0[94];
         rB3 = pB0[126];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rA0 = pA0[31];
         rB0 = pB0[31];
         rB1 = pB0[63];
         rB2 = pB0[95];
         rB3 = pB0[127];
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC0_1 += m5;
         m5 = rA0 * rB1;
         rC0_2 += m6;
         m6 = rA0 * rB2;
         rC0_3 += m7;
         m7 = rA0 * rB3;
         rC0_0 += m0;
         rC0_1 += m1;
         rC0_2 += m2;
         rC0_3 += m3;
         rC0_0 += m4;
         rC0_1 += m5;
         rC0_2 += m6;
         rC0_3 += m7;
         pA0 += incAk;
         pB0 += incBk;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK0x32x32TN32x32x0_a1_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=32, KB=32, 
 * lda=32, ldb=32, ldc=0, mu=2, nu=4, ku=32, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const int Mb = (M>>1)<<1;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((Mb) << 5));
   const double *stN = B + 1024;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*4)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 32
   const int incAm = 32, incAn = -(((Mb) << 5));
   #define incBk 32
   const int incBm = -32, incBn = 128;
   const int incAk0 = ((incAk) >> 5), incBk0 = ((incBk) >> 5);
   #define incCm 4
   const int incCn = (((ldc) << 3)) - (((Mb) << 1));
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0, rB1, rB2, rB3;
   register double m0, m1, m2, m3, m4, m5;
   register double rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rC0_0 = *pC0;
            rC1_0 = pC0[2];
            rC0_1 = *pC1;
            rC1_1 = pC1[2];
            rC0_2 = *pC2;
            rC1_2 = pC2[2];
            rC0_3 = *pC3;
            rC1_3 = pC3[2];
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[32];
            rB1 = pB0[32];
            rB2 = pB0[64];
            m0 = rA0 * rB0;
            rB3 = pB0[96];
            m1 = rA1 * rB0;
            m2 = rA0 * rB1;
            m3 = rA1 * rB1;
            m4 = rA0 * rB2;
            m5 = rA1 * rB2;

/*
 *          Completely unrolled K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[33];
            rB1 = pB0[33];
            rB2 = pB0[65];
            rB3 = pB0[97];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[34];
            rB1 = pB0[34];
            rB2 = pB0[66];
            rB3 = pB0[98];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[35];
            rB1 = pB0[35];
            rB2 = pB0[67];
            rB3 = pB0[99];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[36];
            rB1 = pB0[36];
            rB2 = pB0[68];
            rB3 = pB0[100];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[37];
            rB1 = pB0[37];
            rB2 = pB0[69];
            rB3 = pB0[101];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[38];
            rB1 = pB0[38];
            rB2 = pB0[70];
            rB3 = pB0[102];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[39];
            rB1 = pB0[39];
            rB2 = pB0[71];
            rB3 = pB0[103];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rA1 = pA0[40];
            rB1 = pB0[40];
            rB2 = pB0[72];
            rB3 = pB0[104];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rA1 = pA0[41];
            rB1 = pB0[41];
            rB2 = pB0[73];
            rB3 = pB0[105];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rA1 = pA0[42];
            rB1 = pB0[42];
            rB2 = pB0[74];
            rB3 = pB0[106];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rA1 = pA0[43];
            rB1 = pB0[43];
            rB2 = pB0[75];
            rB3 = pB0[107];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rA1 = pA0[44];
            rB1 = pB0[44];
            rB2 = pB0[76];
            rB3 = pB0[108];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rA1 = pA0[45];
            rB1 = pB0[45];
            rB2 = pB0[77];
            rB3 = pB0[109];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rA1 = pA0[46];
            rB1 = pB0[46];
            rB2 = pB0[78];
            rB3 = pB0[110];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rA1 = pA0[47];
            rB1 = pB0[47];
            rB2 = pB0[79];
            rB3 = pB0[111];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rA1 = pA0[48];
            rB1 = pB0[48];
            rB2 = pB0[80];
            rB3 = pB0[112];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rA1 = pA0[49];
            rB1 = pB0[49];
            rB2 = pB0[81];
            rB3 = pB0[113];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rA1 = pA0[50];
            rB1 = pB0[50];
            rB2 = pB0[82];
            rB3 = pB0[114];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[19];
            rB0 = pB0[19];
            rA1 = pA0[51];
            rB1 = pB0[51];
            rB2 = pB0[83];
            rB3 = pB0[115];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[20];
            rB0 = pB0[20];
            rA1 = pA0[52];
            rB1 = pB0[52];
            rB2 = pB0[84];
            rB3 = pB0[116];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[21];
            rB0 = pB0[21];
            rA1 = pA0[53];
            rB1 = pB0[53];
            rB2 = pB0[85];
            rB3 = pB0[117];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[22];
            rB0 = pB0[22];
            rA1 = pA0[54];
            rB1 = pB0[54];
            rB2 = pB0[86];
            rB3 = pB0[118];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[23];
            rB0 = pB0[23];
            rA1 = pA0[55];
            rB1 = pB0[55];
            rB2 = pB0[87];
            rB3 = pB0[119];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[24];
            rB0 = pB0[24];
            rA1 = pA0[56];
            rB1 = pB0[56];
            rB2 = pB0[88];
            rB3 = pB0[120];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[25];
            rB0 = pB0[25];
            rA1 = pA0[57];
            rB1 = pB0[57];
            rB2 = pB0[89];
            rB3 = pB0[121];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[26];
            rB0 = pB0[26];
            rA1 = pA0[58];
            rB1 = pB0[58];
            rB2 = pB0[90];
            rB3 = pB0[122];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[27];
            rB0 = pB0[27];
            rA1 = pA0[59];
            rB1 = pB0[59];
            rB2 = pB0[91];
            rB3 = pB0[123];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[28];
            rB0 = pB0[28];
            rA1 = pA0[60];
            rB1 = pB0[60];
            rB2 = pB0[92];
            rB3 = pB0[124];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rA0 = pA0[29];
            rB0 = pB0[29];
            rA1 = pA0[61];
            rB1 = pB0[61];
            rB2 = pB0[93];
            rB3 = pB0[125];
            rC0_1 += m4;
            m4 = rA0 * rB0;
            rC1_1 += m5;
            m5 = rA1 * rB0;
            rC0_2 += m0;
            m0 = rA0 * rB1;
            rC1_2 += m1;
            m1 = rA1 * rB1;
            rC0_3 += m2;
            m2 = rA0 * rB2;
            rC1_3 += m3;
            m3 = rA1 * rB2;
            rC0_0 += m4;
            m4 = rA0 * rB3;
            rC1_0 += m5;
            m5 = rA1 * rB3;
            rA0 = pA0[30];
            rB0 = pB0[30];
            rA1 = pA0[62];
            rB1 = pB0[62];
            rB2 = pB0[94];
            rB3 = pB0[126];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rC0_2 += m2;
            m2 = rA0 * rB1;
            rC1_2 += m3;
            m3 = rA1 * rB1;
            rC0_3 += m4;
            m4 = rA0 * rB2;
            rC1_3 += m5;
            m5 = rA1 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rA0 = pA0[31];
            rB0 = pB0[31];
            rA1 = pA0[63];
            rB1 = pB0[63];
            rB2 = pB0[95];
            rB3 = pB0[127];
            rC0_1 += m2;
            m2 = rA0 * rB0;
            rC1_1 += m3;
            m3 = rA1 * rB0;
            rC0_2 += m4;
            m4 = rA0 * rB1;
            rC1_2 += m5;
            m5 = rA1 * rB1;
            rC0_3 += m0;
            m0 = rA0 * rB2;
            rC1_3 += m1;
            m1 = rA1 * rB2;
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m2;
            m2 = rA0 * rB3;
            rC1_0 += m3;
            m3 = rA1 * rB3;
            rC0_1 += m4;
            rC1_1 += m5;
            rC0_2 += m0;
            rC1_2 += m1;
            rC0_3 += m2;
            rC1_3 += m3;
            pA0 += incAk;
            pB0 += incBk;
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            *pC1 = rC0_1;
            pC1[2] = rC1_1;
            *pC2 = rC0_2;
            pC2[2] = rC1_2;
            *pC3 = rC0_3;
            pC3[2] = rC1_3;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_zJIK0x32x32TN1x4x32_a1_b1(k, 32, 32, alpha, ca + (((Mb) << 5)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANM
#define ATL_zpMBmm_b1 ATL_zgpMBmm_b1
#endif

void ATL_zJIK0x32x32TN32x32x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK0x32x32TN32x32x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK0x32x32TN32x32x0_a1_b1(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);

void ATL_zpMBmm_b1(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc)
{
   ATL_zJIK0x32x32TN32x32x0_a1_bX(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_zJIK0x32x32TN32x32x0_a1_bX(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_zJIK0x32x32TN32x32x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_zJIK0x32x32TN32x32x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
